package dev.fitko.fitconnect.api.domain.model.event;

import dev.fitko.fitconnect.api.config.SchemaConfig;

import java.util.HashMap;
import java.util.Map;

import static dev.fitko.fitconnect.api.config.SchemaConfig.EVENTS_SCHEMA_PATH;

public enum Event {

    ACCEPT(EVENTS_SCHEMA_PATH, "accept-submission"),

    REJECT(EVENTS_SCHEMA_PATH, "reject-submission"),

    FORWARD(EVENTS_SCHEMA_PATH, "forward-submission"),

    CREATE(EVENTS_SCHEMA_PATH, "create-submission"),

    SUBMIT(EVENTS_SCHEMA_PATH, "submit-submission"),

    NOTIFY(EVENTS_SCHEMA_PATH, "notify-submission");

    private static final Map<String, Event> CONSTANTS = new HashMap<>();

    static {
        for (final Event c : values()) {
            CONSTANTS.put(c.schema + c.name, c);
        }
    }

    private final String schema;

    private final String name;

    Event(final SchemaConfig schema, final String name) {
        this.schema = schema.toString();
        this.name = name;
    }


    public String getSchema() {
        return this.schema + this.name;
    }

    public String getName(){
        return this.name;
    }

    public static Event fromString(final String eventSchema) {
        return CONSTANTS.get(eventSchema);
    }
}
